import { IFrameTransport } from 'data-transport';
import { ClientToStorage, IChangeData, IOriginStorageClient, OriginStorageClientOptions, StorageToClient } from './interface';
export declare class OriginStorageClient extends IFrameTransport.Main<{
    emit: ClientToStorage;
}> implements StorageToClient, IOriginStorageClient {
    protected _connect?: () => void;
    protected _isConnect: boolean;
    protected _storageOptions?: LocalForageOptions;
    protected _change?: (data: IChangeData) => void;
    protected _uri: string;
    constructor({ storageOptions, uri, ...options }: OriginStorageClientOptions);
    onConnect(callback: () => void): void;
    onChange(callback: (data: IChangeData) => void): Promise<{
        broadcastChanges: boolean;
    }>;
    change(options: {
        key: string | null;
    }): Promise<void>;
    connect(): Promise<LocalForageOptions>;
    getItem(key: string): Promise<unknown>;
    setItem<T>(key: string, value: unknown): Promise<void>;
    removeItem(key: string): Promise<void>;
    clear(): Promise<void>;
    length(): Promise<number>;
    key(index: number): Promise<string>;
    keys(): Promise<string[]>;
}
//# sourceMappingURL=originStorageClient.d.ts.map